# Half-Life: Opposing Force - Issues

Here's a list of things that we'd fix in Half-Life: Opposing Force, given the opportunity.

Same issues as with [Half-Life](Half-Life.md) mostly apply.

**Note:** This is so busted it may very well have to do with undefined behaviour. Run Valgrind all over this codebase man.

## Unreliable item notifications

Observed in multiplayer, some pickups don't trigger a notification at all.

## func_friction is completely broken

Start a multiplayer game on the map `op4ctf_hairball`. It's a very small map - choose any team and walk onto the slippery ice in the middle. You will never stop sliding around. This is a bug introduced within the past decade of game updates.

## CTF powerups are very broken

- Sometimes the yellow ammo powerup never gives any ammo, when it should.
- The longjump powerup never gives you the longjump ability, when it should.
- ...

## You can not save your CTF stats from the VGUI menu when on Linux (and maybe macOS?)

There is an ifdef for Win32 in the function that makes it so only Windows compiles can save stats. The function would need to be edited to work across all supported platforms.

## Missing official maps

Sierra's website provided official ports of a few HL maps to OP4. These were never provided with the Steam release of Half-Life: Opposing Force.

Said maps are:
- [op4_crossfire.bsp](https://www.frag-net.com/dl/addons/halflife/gearbox/op4_crossfire.bsp)
- [op4_frenzy.bsp](https://www.frag-net.com/dl/addons/halflife/gearbox/op4_frenzy.bsp)
- [op4_undertow.bsp](https://www.frag-net.com/dl/addons/halflife/gearbox/op4_undertow.bsp)
- [op4_bounce.bsp](https://www.frag-net.com/dl/addons/halflife/gearbox/op4_bounce.bsp)
- [op4_subtransit.bsp](https://www.frag-net.com/dl/addons/halflife/gearbox/op4_subtransit.bsp)