# Counter-Strike: Source - Issues

Things we'd fix in Counter-Strike: Source given the opportunity.

## Bug: VGUI image button elements BREAK after use

![VGUI](css-vgui.jpg)

As pictured, using a menu on the VGUI menu results in the image losing its scale property.
In the case of some items (e.g. P90) it'll go off-screen entirely, thus becoming invisible.

## Inconsistency: HUD background elements draw only sometimes

![HUD](css-hud.jpg)

The hostage counter and the money counter both do not have background layers that help with the contrast (first introduced in Half-Life 2). This is inconsistent and visually an eyesore once noticed by the player.

Maybe also enable people to disable it entirely? I don't know. Spitballing.